#include <iostream>
#include <cstdlib>
using namespace std;

void wypisz(int *t, int len) {
    for(int i=0; i<len; i++) {
        cout << t[i] << ", ";
    }
    cout << endl;
}

void wypelnij_losowo(int *t, int len, int limit) {
    for(int i=0; i<len; i++) {
        t[i] = rand() % limit;
    }
}

// Funkcja zamienia wartości dwóch zmiennych.
// Parametry są przekazywane "przez referencję".
void swap(int &x, int &y) {
    int z = x;
    x = y;
    y = z;
}

// Funkcja wykonuje jedną rundę popraiania kolejności.
// W wyniku informuje, czy została wykonana chociaż jedna zamiana.
bool popraw(int *t, int len) {
    bool czy_byla_zamiana = false;
    for(int i=1; i<len; i++) {
        if(t[i] < t[i-1]) {
            swap(t[i], t[i-1]);
            czy_byla_zamiana = true;
        }
    }
    return czy_byla_zamiana;
}

void bubble_sort(int *t, int len) {
    do {
        cout << ": ";
        wypisz(t, len);
    } while(popraw(t, len));
}

int main() {
    srand(time(nullptr));
    int a[10];
    wypelnij_losowo(a, 10, 100);
    cout << "wersja wylosowana:\n";
    wypisz(a, 10);
    cout << "sortujemy...\n";
    bubble_sort(a, 10);
    cout << "wersja posortowana:\n";
    wypisz(a, 10);

    return 0;
}

/* Sortowanie to zadanie polegające na ułożeniu elementów
   w kolejności uporządkowanej (np. rosnącej).
   Istnieje wiele algorytmów sortowania,
   które różnią się wydajnością. Są to m.in.:
   - bubble sort (robimy tutaj)
   - insertion sort
   - merge sort
   - quick sort
*/
