#include <iostream>
using namespace std;

// Zmienne zadeklarowane przed wszystkimi funkcjami, to są "zmienne globalne"
// Są one widoczne we wszystkich funkcjach programu.
// Tu ich użyjemy, ale w prawdziwym programowaniu są raczej niezalecane.

// W planszy pamiętamy znak ' ', jeśli pole jest wolne,
// a znaki 'O' lub 'X' jako kółko i krzyżyk
char plansza[3][3];
string imie[2];
char znak[2] = {'O', 'X'};

enum StanGry {
    GRA_TRWA, REMIS, WYGRAL_O, WYGRAL_X
};

StanGry stan = GRA_TRWA;

void inicjuj_plansze() {
    for(int i=0; i<3; i++) {
        for(int j=0; j<3; j++) {
            plansza[i][j] = ' ';
        }
    }
}

void wypisz_plansze() {
    for(int i=0; i<3; i++) {
        if(i > 0) {
            cout << "---+---+---\n";
        }
        for(int j=0; j<3; j++) {
            if(j > 0) {
                cout << " |";
            }
            cout << " " << plansza[i][j];
        }
        cout << " \n";
    }
}

bool ustaw_pole(char ruch, char co_ustawic) {
    int x, y;
    switch(ruch) {
        case 'Q': case 'q': case '7': x = 0; y = 0; break;
        case 'W': case 'w': case '8': x = 0; y = 1; break;
        case 'E': case 'e': case '9': x = 0; y = 2; break;
        case 'A': case 'a': case '4': x = 1; y = 0; break;
        case 'S': case 's': case '5': x = 1; y = 1; break;
        case 'D': case 'd': case '6': x = 1; y = 2; break;
        case 'Z': case 'z': case '1': x = 2; y = 0; break;
        case 'X': case 'x': case '2': x = 2; y = 1; break;
        case 'C': case 'c': case '3': x = 2; y = 2; break;
        default:
            cout << "Nieznany ruch\n";
            return false;
    }
    if(plansza[x][y] != ' ') {
        cout << "Pole zajęte\n";
        return false;
    }
    plansza[x][y] = co_ustawic;
    return true;
}

StanGry sprawdz_sytuacje() {
    if(   plansza[0][0] == 'O' && plansza[0][1] == 'O' && plansza[0][2] == 'O'
       || plansza[1][0] == 'O' && plansza[1][1] == 'O' && plansza[1][2] == 'O'
       || plansza[2][0] == 'O' && plansza[2][1] == 'O' && plansza[2][2] == 'O'
       || plansza[0][0] == 'O' && plansza[1][0] == 'O' && plansza[2][0] == 'O'
       || plansza[0][1] == 'O' && plansza[1][1] == 'O' && plansza[2][1] == 'O'
       || plansza[0][2] == 'O' && plansza[1][2] == 'O' && plansza[2][2] == 'O'
       || plansza[0][0] == 'O' && plansza[1][1] == 'O' && plansza[2][2] == 'O'
       || plansza[0][2] == 'O' && plansza[1][1] == 'O' && plansza[2][0] == 'O'
    ) {
        return WYGRAL_O;
    }
    if(   plansza[0][0] == 'X' && plansza[0][1] == 'X' && plansza[0][2] == 'X'
       || plansza[1][0] == 'X' && plansza[1][1] == 'X' && plansza[1][2] == 'X'
       || plansza[2][0] == 'X' && plansza[2][1] == 'X' && plansza[2][2] == 'X'
       || plansza[0][0] == 'X' && plansza[1][0] == 'X' && plansza[2][0] == 'X'
       || plansza[0][1] == 'X' && plansza[1][1] == 'X' && plansza[2][1] == 'X'
       || plansza[0][2] == 'X' && plansza[1][2] == 'X' && plansza[2][2] == 'X'
       || plansza[0][0] == 'X' && plansza[1][1] == 'X' && plansza[2][2] == 'X'
       || plansza[0][2] == 'X' && plansza[1][1] == 'X' && plansza[2][0] == 'X'
    ) {
        return WYGRAL_X;
    }
    if(   plansza[0][0] != ' ' && plansza[0][1] != ' ' && plansza[0][2] != ' '
       && plansza[1][0] != ' ' && plansza[1][1] != ' ' && plansza[1][2] != ' '
       && plansza[2][0] != ' ' && plansza[2][1] != ' ' && plansza[2][2] != ' ') {
        return REMIS;
    }
    return GRA_TRWA;
}

int main() {
    cout << "Podaj imię pierwszego gracza: " << flush;
    cin >> imie[0];
    cout << "Podaj imię drugiego gracza: " << flush;
    cin >> imie[1];

    inicjuj_plansze();
    wypisz_plansze();
    int kto = 0;
    char ruch;
    do {
        cout << imie[kto] << ", podaj swój ruch: " << flush;
        cin >> ruch;
        if(!ustaw_pole(ruch, znak[kto])) {
            continue;
        }
        wypisz_plansze();
        stan = sprawdz_sytuacje();
        kto = (kto+1)%2; // to naprzemiennie zmienia wartość zmiennej między 0 a 1
    } while(stan == GRA_TRWA);

    switch(stan) {
        case WYGRAL_O:
            cout << "Wygrało kółko, czyli " << imie[0] << "!\n";
            break;
        case WYGRAL_X:
            cout << "Wygrał krzyżyk, czyli " << imie[1] << "!\n";
            break;
        case REMIS:
            cout << "Remis\n";
            break;
    }
    return 0;
}
